

import lbi.utils.*;

import java.io.*;
import java.sql.*;
import java.util.*;

class MInteger {
	public int value = 0;
}

class MDouble {
	public double value = 0;
}

public class MPD {

	    public static void main(String[] args) throws SQLException, IOException {
//	 load proprierties
	        Properties props = IOUtil.readProps("myJDBCdef.props");
//	 load drivers
	        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
//	 connect to data source, using userName and userPWD
	        String url = props.getProperty("jdbcURL");
	        String user = props.getProperty("userName");
	        String pwd = props.getProperty("userPWD");
	        Connection con = DriverManager.getConnection(url, user, pwd);
	        Statement stmt = con.createStatement();
//	   	 retrieve table and column from properties
	        
			HashMap<Integer, String> cust2name = new HashMap<Integer, String>();
			ResultSet rs = stmt.executeQuery("SELECT * FROM customer");
			while( rs.next() ) {
				int customer_id = rs.getInt("customer_id");
				String full_name = rs.getString("fname") + " " + rs.getString("lname");
				cust2name.put(customer_id, full_name);
			}
	        
	        HashMap<String, MInteger> time2num = new HashMap<String, MInteger>();
	        HashMap<Integer, String> id2time = new HashMap<Integer, String>();
	        rs = stmt.executeQuery("SELECT * FROM time_by_day");
			while( rs.next() ) {
				int time_id = rs.getInt("time_id");
				int the_year = rs.getInt("the_year");
				String the_month = rs.getString("the_month");
				String yearmonth = the_year + "," + the_month;
				id2time.put(time_id,  yearmonth);
				String the_day = rs.getString("the_day");
				if(the_day.equals("Sunday"))
					continue;
				MInteger ndays = time2num.get(yearmonth);
				if(ndays==null) {
					ndays = new MInteger();
					time2num.put(yearmonth, ndays);
				}
				ndays.value++;
			}

	        rs = stmt.executeQuery("SELECT * FROM sales_fact");
	        HashMap<String, MDouble> customer2sales = new HashMap<String, MDouble>();
			while( rs.next() ) {
				int customer_id = rs.getInt("customer_id");
				int time_id = rs.getInt("time_id");
				String yearmonth = id2time.get(time_id);
				String custtime = customer_id + "," + yearmonth;
				MDouble sales = customer2sales.get(custtime);
				if(sales==null) {
					sales = new MDouble();
					customer2sales.put(custtime, sales);
				}
				sales.value += rs.getDouble("store_sales");				
			}
	        con.close();

	        PrintWriter output = IOUtil.getWriter("");
	        for(String custtime : customer2sales.keySet()) {
	        	int comma = custtime.indexOf(",");
	        	String cust_id = custtime.substring(0, comma);
	        	String yearmonth = custtime.substring(comma+1);
	        	int customer_id = Integer.parseInt(cust_id);
	        	String full_name = cust2name.get(customer_id);
	        	double mpd = customer2sales.get(custtime).value / time2num.get(yearmonth).value;
	        	output.println(full_name+","+yearmonth+","+mpd);
	        }
	        output.close();
	    }
	}