with nonsundays as
(
  select the_year, the_month, count(*) as nonsundays
  from time_by_day
  where the_day != 'Sunday'
  group by the_year, the_month
),
sales_temp as
(
  select customer_id, the_year, the_month, sum(store_sales) as sum_sales
  from sales_fact join time_by_day on sales_fact.time_id = time_by_day.time_id
  group by customer_id, the_year, the_month
),
sales as
(
  select customer.lname + ' ' + customer.fname as full_name, the_year, the_month, sum_sales
  from sales_temp join customer on sales_temp.customer_id = customer.customer_id
)
select full_name, sales.the_year, sales.the_month, sum_sales/nonsundays as MPD
from sales join nonsundays on sales.the_month = nonsundays.the_month and sales.the_year = nonsundays.the_year
order by sum_sales/nonsundays desc